#ifndef DERIVED_H
#define DERIVED_H

#include "Base.h"

class Derived : public Base{
//class Derived : protected Base{
//class Derived : private Base{
private:
	int newData;
public:
	/*
	Descr:	constructor
	In:		 -
	Out: an instance of Derived
	*/
	Derived():Base(){
		cout << "[Derived] : default constructor " << endl;	
		this->newData = 0;
	}
	/*
	Descr:	constructor
	In:		4 numbers
	Out:	an instance of Derived
	*/
	Derived(int d1, int d2, int d3, int d4):Base(d1, d2, d3){
		cout << "[Derived] : general constructor " << endl;
		this->newData = d4;
	}
	/*
	Descr:	copy constructor
	In:		an object d of type Derived
	Out:	an instance of Derived (with info from d)
	*/
	Derived(const Derived& d):Base(d){
		cout << "[Derived] : copy constructor " << endl;
		this->newData = d.newData;
	}
	/*
	Descr:	destructor
	In:		crt instance of Derived
	Out:	- 
	*/
	~Derived(){
		cout << "[Derived] : destructor " << endl;
	}
	
	/*
	Descr:	assignment operator
	In:		the crt instance of Derived and an object d of type Derived
	Out:	the crt instance of Derived (with info from d)
	*/
	Derived& operator=(const Derived &d){
		cout << "[Derived] : operator= " << endl;
		if (this != &d){			
			Base::operator=(d);
			this->newData = d.newData;
		}
		return *this;
	}
	
	/*
	Descr:	setter
	In:		the crt instance of Derived and a number
	Out:	the changed instance of Derived
	*/
	void setNewData(int d){
		newData = d;
	}
	/*
	Descr:	getter
	In:		the crt instance of Derived
	Out:	the value of an attribute of crt Derived instance
	*/
	int getNewData(){
		return this->newData;
	}
	/*
	Descr:	converter to string
	In:		the crt instance of Derived
	Out:	the string associated to info from crt Derived instance
	*/
	char* toString(){
		char* s = new char[5 * 6];
		char* aux = new char[6];
		_itoa_s(this->publicData, aux, 6, 10);
		strcpy_s(s, 30, aux);
		strcat_s(s, 30, " ");
		_itoa_s(this->protectedData, aux, 6, 10);
		strcat_s(s, 30, aux);
		strcat_s(s, 30, " ");
		_itoa_s(this->getPrivateData(), aux, 6, 10);
		strcat_s(s, 30, aux);
		strcat_s(s, 30, " ");
		_itoa_s(this->newData, aux, 6, 10);
		strcat_s(s, 30, aux);
		delete[] aux;
		return s;
	}
};
#endif